/* LMI/lmi06/ALGOGEOM/TD/TPenv3/ENVCONV3/env3.c*/
/*---------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include "env3.h"

/* ------------------VARIABLES GLOBALES ---------------*/

int NP=0;                  /* nombre de points */
int NA=0;                  /* nombre d'aretes dans ART*/
int NS=0;                  /* nombre de sommets dans SOM */
int NF=0;                  /* nombre de faces dans FACES */
Point *POINTS[NPMAX];      /* tableau de tous les  (Point *) */
Arete *ART[NPMAX];         /* tableau des (Arete *) */
Point *SOM[NPMAX];         /* tableau de tous les sommets */
Arete *FACES[NPMAX];       /* tableau des faces */
/* ---------------------FONCTIONS ---------------------*/
/* allocation memoire */
Point *Palloc(void)
{ return((Point *)malloc(sizeof(Point)));}
Arete *Aalloc(void)
{ return((Arete *)malloc(sizeof(Arete)));}
int *ialloc(void)
{ return((int *)malloc(sizeof(int)));}



/* Entrees-sorties */
void lire_tab_points( void )
{ int n = 0; 
  int *xtemp=ialloc(); 
  int *ytemp=ialloc();
  int *ztemp=ialloc();
  printf("#VRML V2.0 \n"); 
  printf("#donnez-moi des points, au plus %3d \n",NPMAX);
  while (( n < NPMAX) && (scanf("%d %d %d",xtemp,ytemp,ztemp) != EOF))
     { POINTS[n]=Palloc();
       POINTS[n]->x= *xtemp;
       POINTS[n]->y= *ytemp;
       POINTS[n]->z= *ztemp;
       printf("#(%d,%d,%d)\n",(POINTS[n])->x,(POINTS[n])->y,(POINTS[n])->z);
       ++n;}
   {if (n < NPMAX) 
       {NP=n; printf("#%3d points lus\n",n);}
     else
       printf("#%3d points lus; nombre max est atteint;\n les autres points ne seront pas lus \n",n);}}
void ecrire_point(Point *A) 
{printf("#Point (%d,%d,%d)\n",A->x,A->y,A->z);}

void ecrire_arete(Arete *A) 
{printf("#arete d'origine (%d,%d,%d)",A->ori->x,A->ori->y,A->ori->z);
 printf(" et d' extremite (%d,%d,%d)\n",A->ext->x,A->ext->y,A->ext->z);}


void ecrire_tab_points(Point *P[],int NP)
{ int n = 0;
  printf("#Liste des points \n");
    while ( n < NP)
      {ecrire_point(P[n]);n++;}}

void ecrire_tab_aretes(Arete *A[],int NA)
{ int n = 0;
  printf("#Liste des aretes \n");
    while ( n < NA)
      {ecrire_arete(A[n]);n++;}}

extern void ecrire_wrml(void)
{ int i;
  printf( "#VRML V2.0\n");
  printf("NavigationInfo { type \"EXAMINE\"}\n");
  printf("Group{ children[\n");
  printf("##premier fils de Group: polytope, squelette, rouge translucide\n"); 
  printf("Shape {appearance Appearance {material  Material {\n");
  printf("ambientIntensity 0.4\n");
  printf("diffuseColor  1 0 0\n");
  printf("transparency  0.5  }}\n");
  printf("geometry IndexedLineSet {coord Coordinate{\n");
  printf("point [\n");
  /*les coordonnees des sommets: x1 x2 x3 ,*/
  for (i=0;i<NS;i++)
    printf("%d  %d  %d ,\n",SOM[i]->x,SOM[i]->y,SOM[i]->z);
  printf("]}\n"); 
  printf("coordIndex[\n");
  /* les indices des aretes:num1 num2 -1 */
  for (i=0;i<NA;i++)
    printf("%d  %d  -1 \n",ART[i]->ori->num,ART[i]->ext->num);
  printf("]}}\n");
  printf("##autres fils de Group: spheres vertes mates sur les sommets\n");
  for(i=0;i<NS;i++)
    {
     printf("Transform { translation ");
     printf("%d  %d  %d \n",SOM[i]->x,SOM[i]->y,SOM[i]->z); 
     /* coordonnees du sommet: x1 x2 x3 */
     printf("children[ Shape {\n");
     printf("appearance Appearance { material  Material { \n");
     printf("ambientIntensity 0.4 \n");
     printf("diffuseColor  0 1 0 \n");
     printf("transparency  0   }} \n");
     printf("geometry Sphere{ radius 0.2}}]} \n");};

   printf("##autres fils de Group: spheres bleues mates sur les non-sommets\n");
   for(i=0;i<NP;i++)
     if(!POINTS[i]->m)
       {printf("Transform { translation ");
        printf("%d  %d  %d \n",POINTS[i]->x,POINTS[i]->y,POINTS[i]->z);
        printf("children[ Shape { \n");
        printf("appearance Appearance { material  Material {\n");
        printf("ambientIntensity 0.4\n");
        printf("diffuseColor  0  0  1\n");
        printf("transparency  0   }}\n");
        printf("geometry Sphere{ radius 0.2}}]}\n");}
 
  printf("]}\n");
  /*fin des children, fin du groupe */
 }
 
/* Comparaisons */


int compare_x(const void *p1, const void *p2) 
{Point *pp1=*(Point **)p1;
 Point *pp2=*(Point **)p2;
 int comp;

 if (pp1->x < pp2->x)
   comp=-1;
 else if (pp1->x==pp2->x)
       comp=0;
       else comp=1;
 /* printf("(%d,%d,%d)< (%d,%d,%d) donne %d\n",pp1->x,pp1->y,pp1->z,pp2->x,pp2->y,pp2->z,comp); */
 return(comp);}

int compare_moinsx(const void *p1, const void *p2) 
{Point *pp1=*(Point **)p1;
 Point *pp2=*(Point **)p2;
 int comp;

 if (pp1->x > pp2->x)
   comp=-1;
 else if (pp1->x==pp2->x)
       comp=0;
       else comp=1;
 /* printf("(%d,%d,%d)< (%d,%d,%d) donne %d\n",pp1->x,pp1->y,pp1->z,pp2->x,pp2->y,pp2->z,comp); */
 return(comp);}

int index_max(void *tab, int imin, int imax, int sizeofelt, int(*cmp)(const void *,const void *))
{ int i,vainqueur; 
  vainqueur=imin; 
  for (i=imin; i<= imax;i++) 
    if ((*cmp)((tab + i*sizeofelt),(tab + vainqueur*sizeofelt))==1) 
      vainqueur=i; 
  return(vainqueur);
}

int succ(int i)
{if (i==NA-1) return(0);
  else return(i+1);}

int pred(int i)
{if (i==0) return(NA-1);
  else return(i-1);}

/* geometrie */
int det2(Point *p1, Point *p2)       /* determinant projection sur x,y */
{return((p1->x * p2->y)-(p1->y * p2->x));}

int detaff2(Point *pp1, Point *p1, Point *pp2, Point *p2)
{return(((p1->x -pp1->x)* (p2->y- pp2->y))-((p1->y -pp1->y)* (p2->x-pp2->x)));}

int det(Point *p1, Point *p2, Point *p3)
{return(((p1->x)*(p2->y)*(p3->z)+ (p1->y)*(p2->z)*(p3->x)+(p1->z)*(p2->x)*(p3->y))-
        ((p1->y)*(p2->x)*(p3->z)+ (p1->z)*(p2->y)*(p3->x)+(p1->x)*(p2->z)*(p3->y)));}

int detaff(Point *pp1,Point *p1,Point *pp2,Point *p2, Point *pp3,Point *p3)
{return(((p1->x-pp1->x)*(p2->y-pp2->y)*(p3->z-pp3->z)+ (p1->y-pp1->y)*(p2->z-pp2->z)*(p3->x-pp3->x)+(p1->z-pp1->z)*(p2->x-pp2->x)*(p3->y-pp3->y))-
        ((p1->y-pp1->y)*(p2->x-pp2->x)*(p3->z-pp3->z)+ (p1->z-pp1->z)*(p2->y-pp2->y)*(p3->x-pp3->x)+(p1->x-pp1->x)*(p2->z-pp2->z)*(p3->y-pp3->y)));}

Arete *arete_init(int imin, int imax1, int imax2)
{int i1,i2;                              /* index des points de depart*/
 int fini=0;                             /* booleen */
 Arete *Ainit1,*Ainit2;                  /* aretes de depart */
 Arete *Acour1,*Acour2;                  /* aretes courantes */
 Arete *vq1,*vq2;                        /* vainqueurs */
 Arete *A=Aalloc();Arete *Ainv=Aalloc(); /* l'arete la plus haute en y et son inverse */
 A->inv=Ainv;Ainv->inv=A;
 i1=index_max(POINTS,imin,imax1,sizeof(Point *),compare_x);
 i2=index_max(POINTS,imax1+1,imax2,sizeof(Point *),compare_moinsx);
 A->ori=Ainv->ext=POINTS[i1];A->ext=Ainv->ori=POINTS[i2];
 while(!fini)
  {vq1=Ainit1=A->ori->art;
   vq2=Ainit2=A->ext->art;
   Acour1=Ainit1->suiv;Acour2=Ainit2->suiv;
   while(Acour1 != Ainit1)
     {if ((detaff2(A->ori,A->ext,Acour1->ori,Acour1->ext)>0) && 
           ((detaff2(A->ori,A->ext,vq1->ori,vq1->ext) <=0) || 
           (detaff2(Acour1->ori,Acour1->ext,vq1->ori,vq1->ext)>0)))
	   /* Acour1 est meilleur que vq1 */
	   vq1=Acour1;
      Acour1=Acour1->suiv;}
   while(Acour2 != Ainit2)
     {if ((detaff2(A->ori,A->ext,Acour2->ori,Acour2->ext)>0) && 
           ((detaff2(A->ori,A->ext,vq2->ori,vq2->ext) <=0) || 
           (detaff2(Acour2->ori,Acour2->ext,vq2->ori,vq2->ext)<0)))
	   /* Acour2 est meilleur que vq2 */
	   vq2=Acour2;
       Acour2=Acour2->suiv;}
   if (detaff2(A->ori,A->ext,vq1->ori,vq1->ext) >0)
     A->ori=Ainv->ext=vq1->ext;
   else if(detaff2(A->ori,A->ext,vq2->ori,vq2->ext) >0)
     A->ext=Ainv->ori=vq2->ext;
   else fini=1;}
 return(A);}
  
 Arete *vainqueur1(Arete *A)
{Arete *Acour0,*Acour1,*Acour2; /*3 aretes successives, sens indirect*/
  int D10,D12; /* determinants */
  int victoire; /* booleen */
  Acour1=A->ori->art; Acour2=Acour1->pred; Acour0=Acour1->suiv;
  D10=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour0->ori,Acour0->ext);
  D12=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour2->ori,Acour2->ext);
  victoire=(D10 > 0 && D12 >=0);
  while (!victoire)
    {Acour0=Acour1;Acour1=Acour2;Acour2=Acour1->pred;
     D10 =-D12; D12=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour2->ori,Acour2->ext);
     victoire=(D10 > 0 && D12 >=0);}
  A->ori->art=Acour1;     /* memorise le dernier vainqueur de A->ori */
  return(Acour1);}

Arete *vainqueur2(Arete *A)
{Arete *Acour0,*Acour1,*Acour2; /*3 aretes successives, sens direct*/
  int D10,D12;  /* determinants */
  int victoire; /* booleen */
  Acour1=A->ext->art; Acour2=Acour1->suiv; Acour0=Acour1->pred;
  D10=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour0->ori,Acour0->ext);
  D12=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour2->ori,Acour2->ext);
  victoire=(D10 > 0 && D12 >=0);
  while (!victoire)
    {Acour0=Acour1;Acour1=Acour2;Acour2=Acour1->suiv;
     D10=-D12;D12=detaff(A->ori,A->ext,Acour1->ori,Acour1->ext,Acour2->ori,Acour2->ext);
     victoire=(D10 > 0 && D12 >=0);}
  A->ext->art=Acour1;     /* memorise le dernier vainqueur de A->ori */
  return(Acour1);}

int cylindre(int imin, int imax1, int imax2)
{ Arete *Acour,*Ainv, *vq1, *vq2; /* arete courante, son inverse et ses deux vainqueurs */
  Point *Pcour1,*Pcour2;
  int i1,i2,NAC; i1=i2=0;
  Acour=arete_init(imin, imax1, imax2);
  printf("#Arete initiale du cylindre:\n");
  ecrire_arete(Acour);
  Pcour1=Acour->ori; Pcour2=Acour->ext;
  /* arete la plus haute (par rapport a y) joignant conv(imin--imax1) a conv(imax1+1--imax2) */
  while (1)
    {vq1=vainqueur1(Acour);vq2=vainqueur2(Acour);
     printf("#pivot:  ");ecrire_arete(Acour);
     printf("#vainqueur1:\n");ecrire_arete(vq1);
     printf("#vainqueur2:\n");ecrire_arete(vq2);
      if(detaff(Acour->ori,Acour->ext,vq1->ori,vq1->ext,vq2->ori,vq2->ext)>0)

        /* then vq1->ext--Pcour2 est la nouvelle arete pivot*/
	{Acour->pred=vq1;          /* lien nouv-->violet */
	 ART[i1+i2]=Acour;         /* ranger ancien pivot */
         Pcour1=vq1->ext;          /* nouveau point */
         if (Pcour1==ART[0]->ori && Pcour2==ART[0]->ext)  
	   {Acour=ART[0];Ainv=ART[0]->inv;}           /* si depart est atteint */
	 else
	   {Acour=Aalloc();Ainv=Aalloc();Acour->inv=Ainv;Ainv->inv=Acour;
	    Acour->ori=Ainv->ext=Pcour1; Acour->ext=Ainv->ori=Pcour2;} 
         Acour->suiv=vq1->inv;                        /* lien  nouv-->violet */
         Ainv->pred=ART[i1+i2]->inv; ART[i1+i2]->inv->suiv=Ainv; /*2 liens nouv-->nouv */
         if (Pcour1==ART[0]->ori && Pcour2==ART[0]->ext) {NAC=i1+i2+1;return(NAC);}
         /* sortie si on retrouve l'arete de depart , sinon */
	 else i1++;}

        /* else Pcour1--vq2->ext est la nouvelle arete */
      else
        {Acour->inv->suiv=vq2;  /* lien nouv-->violet */
	 ART[i1+i2]=Acour;      /* ranger ancien pivot */
         Pcour2=vq2->ext;       /* nouveau point */
         if (Pcour1==ART[0]->ori && Pcour2==ART[0]->ext) 
           {Acour=ART[0];Ainv=ART[0]->inv;}           /* si depart est atteint */
         else
	   {Acour=Aalloc();Ainv=Aalloc();Acour->inv=Ainv;Ainv->inv=Acour;
	    Acour->ori=Ainv->ext=Pcour1; Acour->ext=Ainv->ori=Pcour2;}
         Acour->inv->pred=vq2->inv;                  /* lien  nouv-->violet */
         Acour->suiv=ART[i1+i2]; ART[i1+i2]->pred=Acour; /*2 liens nouv-->nouv */
         if (Pcour1==ART[0]->ori && Pcour2==ART[0]->ext) {NAC=i1+i2+1;return(NAC);}
         /* sortie si on retrouve l'arete de depart */
	 else i2++;}}}

void fusion(int imin, int imax1, int imax2)
{Arete *A;int i;
  NA=cylindre(imin, imax1, imax2);
  printf("#Nombre d'aretes dans le cylindre:%d\n",NA);
  for(i=0;i<NA;i++)
    {A=ART[i];printf("#valeur de i %d\n",i);
    ecrire_arete(ART[i]);
      /* 4 liens violet-->nouv */
      if (A->suiv      !=ART[pred(i)]) A->suiv->pred=A; 
      if (A->pred      !=ART[succ(i)]) A->pred->suiv=A;
      if (A->inv->suiv !=ART[succ(i)]->inv) A->inv->suiv->pred=A->inv;
      if (A->inv->pred !=ART[pred(i)]->inv) A->inv->pred->suiv=A->inv;
      /* affecter l'arete a son origine */
      A->ori->art=A;A->ext->art=A->inv;};}

void tetraedre(int imin,int imax)
/* on suppose imax-imin +1==4*/
{Arete *A;Arete *AR[4][4];
 int i,j;
 /* creer les 12 brins */
 for(i=imin; i< imax; i++)
   for(j=i+1;j<= imax;j++)
     { A=Aalloc();AR[i%4][j%4]=A;
       A->ori=POINTS[i];
       A->ext=POINTS[j];
       A->inv=Aalloc();AR[j%4][i%4]=A->inv;
       A->inv->ori=POINTS[j];
       A->inv->ext=POINTS[i];
       A->inv->inv=A;
       A->ori->art=A;
       A->ext->art=A->inv;
       printf("#indices %d,%d\n",i%4,j%4);
       ecrire_arete(AR[i%4][j%4]);ecrire_arete(AR[i%4][j%4]->inv);}
 /* orienter */
 for(i=imin; i<= imax; i++)
   {if(detaff(AR[i%4][(i+1)%4]->ori,AR[i%4][(i+1)%4]->ext,AR[i%4][(i+2)%4]->ori,AR[i%4][(i+2)%4]->ext,AR[i%4][(i+3)%4]->ori,AR[i%4][(i+3)%4]->ext)>0)
       for(j=0;j<3;j++)
	 { AR[i%4][(i+1+j%3)%4]->pred=AR[i%4][(i+1+(j+1)%3)%4];
           printf("#(%d,%d)-pred-> (%d,%d)\n",i%4,(i+1+j%3)%4,i%4,(i+1+(j+1)%3)%4);
	   AR[i%4][(i+1+j%3)%4]->suiv=AR[i%4][(i+1+(j+2)%3)%4];
           printf("#(%d,%d) -suiv-> (%d,%d)\n",i%4,(i+1+j%3)%4,i%4,(i+1+(j+2)%3)%4);}
     else
       for(j=0;j<3;j++)
	 { AR[i%4][(i+1+j%3)%4]->suiv=AR[i%4][(i+1+(j+1)%3)%4];
           printf("#(%d,%d)-suiv-> (%d,%d)\n",i%4,(i+1+j%3)%4,i%4,(i+1+(j+1)%3)%4);
	   AR[i%4][(i+1+j%3)%4]->pred=AR[i%4][(i+1+(j+2)%3)%4];
           printf("#(%d,%d) -pred-> (%d,%d)\n",i%4,(i+1+j%3)%4,i%4,(i+1+(j+2)%3)%4);}}
}
       

void enveloppe(int imin, int imax)
{if (imax-imin+1==4) tetraedre(imin,imax);
  else {enveloppe(imin,(imin + imax+1)/2 -1);
        enveloppe((imin + imax+1)/2 , imax);
        fusion(imin,(imin + imax+1)/2 -1,imax);}}

/* enumerations */
void parcours_face(Arete *A)  /* OK */
{if (!A->m)
    { Arete *Acour;
      FACES[NF]=A;NF++;
      printf("#une face \n");
      ecrire_arete(A);
      A->m=1;Acour=A->inv->pred;ecrire_arete(Acour); 
      while (Acour != A)
	{Acour->m=1;Acour=Acour->inv->pred;ecrire_arete(Acour);}}}

void parcours_som(Arete *A)
/* si A->ori est non-marque: insere A->ori dans SOM, marque A->ori, parcourt toutes les faces incidentes,lance parcours_som sur tous les voisins de A->ori */ 
{if (!A->ori->m)
    { Arete *Acour;
      SOM[NS]=A->ori;A->ori->m=1;A->ori->num=NS;ecrire_point(SOM[NS]);
      NS++;
      parcours_face(A);
      Acour=A->suiv;
      while (Acour != A)
	{parcours_face(Acour);Acour=Acour->suiv;}
      parcours_som(A->inv);
      Acour=A->suiv;
      while (Acour != A)
	{parcours_som(Acour->inv);Acour=Acour->suiv;}}}

void parcours_art()
{Arete *A,*Acour;
 int i;
 NA=0;
 for(i=0;i<NS;i++)
   {A=SOM[i]->art;
    ART[NA]=A;NA++;
    Acour=A->suiv;
    while (Acour != A)
	{ART[NA]=Acour;NA++;Acour=Acour->suiv;}}}
  
int euler() /* retourne la caracteristique d'Euler-Poincare */
{return(NF-NA/2+NS);}
/* ---------------------ALGO ---------------------*/
     /* Lire les points */
     /* Completer en une puissance de 2 */
     /* Calculer l'enveloppe convexe */
     /* Generer le wrml */
/* -----------------------------------------------*/

int main()
{    /* Arete *Acour,*A; */
     lire_tab_points();
     ecrire_tab_points(POINTS,NP);

     /* Completer en une puissance de 2 */

     /* Calculer l'enveloppe convexe */
     qsort(POINTS,NP,sizeof(Point *),compare_x); 
     enveloppe(0,NP-1);

     /* Generation du wrml */
    printf("#parcours des sommets\n");
    parcours_som(POINTS[0]->art);
    parcours_art();
    printf("#Nombre de faces :%d\n",NF);
    printf("#Nombre d'aretes :%d\n",NA/2);
    printf("#Nombre de sommets :%d\n",NS);
    printf("#Caracteristique d'Euler :%d\n",euler()); 
    
    ecrire_wrml();
    return(EXIT_SUCCESS);
}


